/* dq_main - test routine for deque package
 */
#include "local.h"
#include "deque.h"
DQ_NODE *dq = NULL;
#define MYNODE struct mynode
MYNODE
	{
	MYNODE *left;
	MYNODE *right;
	int data;
	};
#define LINESIZE 20
main()
	{
	MYNODE *p;			/* current node */
	char buf[LINESIZE];	/* buffer for input */

	DQ_OPEN(&dq);
	printf("Type < to push (insert at left end of deque)\n");
	printf("Type > to enque (insert at right end of deque)\n");
	printf("Type - to pop (remove leftmost node)\n");
	printf("Type = to print contents of deque\n");
	printf("Type 0 to reset deque\n");
	for (;;)
		{
		getreply("?: ", buf, 2);
		switch (buf[0])
			{
		case '<':
			p = (MYNODE *)malloc(sizeof(MYNODE));
			if (p == NULL)
				error("out of space", "");
			getreply("data: ", buf, 5);	/* bound to 4 digits */
			p->data = atoi(buf);
			DQ_PUSH(dq, p);
			break;
		case '>':
			p = (MYNODE *)malloc(sizeof(MYNODE));
			if (p == NULL)
				error("out of space", "");
			getreply("data: ", buf, 5);	/* bound to 4 digits */
			p->data = atoi(buf);
			DQ_APPEND(dq, p);
			break;
		case '-':
			p = (MYNODE *)DQ_POP(dq);
			if (p == NULL)
				printf("EMPTY DEQUE\n");
			else
				{
				printf("data=%6d\n", p->data);
				free((data_ptr)p);
				}
			break;
		case '=':
			if (DQ_IS_EMPTY(dq))
				printf("EMPTY DEQUE\n");
			else
				EACH_DQ(dq, p, MYNODE)
					printf("data=%6d\n", p->data);
			break;
		case '0':
			DQ_CLOSE(&dq);
			break;
		default:
			printf("unknown command: %c\n", buf[0]);
			break;
			}
		}
	}
